--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

package Railway.Stations is
   pragma Remote_Call_Interface;

   --  called by Trains
   --+ when they Arrive at a Station
   --  train enqueues at the Platform
   procedure Train_Arrived_Platform
     (Platform_Number : Platform_ID_T;
      Train_Name : String;
      Train_Number : Range_Trains;
      Free_Seats : Integer;
      Seats : Integer;
      Destination : String);

   --  train boards Passengers
   procedure Stopping_Platform
     (Platform_Number : Platform_ID_T;
      Train_Name : String;
      Train_Number : Range_Trains;
      Free_Seats : Integer;
      Seats : Integer;
      Destination : String);

   --  train Departs
   procedure Boarding_Platform
     (Platform_Number : Platform_ID_T;
      Train_Name : String;
      Next_Stage : Integer;
      Destination : String);

   --  train Departs
   procedure Close_Doors_Platform
     (Platform_Number : Platform_ID_T;
      Train_Name : String;
      Free_Seats : out Integer;
      Destination : String);

   --  get the platform name from the given platform ID
   function Get_Platform_Name (Platform_Number : Platform_ID_T) return String;

   --  get the station name from the given platform ID
   function Get_Platform_Station (Platform_Number : Platform_ID_T) return String;

   --  starts the passenger's travel
   procedure Passenger_Travel
     (Passenger_Route : Travel_Route_T;
      Travel_Index : in out Integer;
      Passenger_Name : String);


end Railway.Stations;
