--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------


package Railway.Tracks is
   pragma Remote_Call_Interface;

   --  gets the track - blocking procedure
   procedure Enter_Track (Track_Number : Track_ID_T;
                         Train_Number  : Integer;
                         Train_Name    : String;
                         Seats         : Integer;
                         Seatsmax      : Integer);

   --  release the track
   procedure Leave_Track (Track_Number : Track_ID_T;
                          Train_Name   : String);
   pragma Asynchronous (Leave_Track);

   --  gets the length in Km of track with given ID
   function Get_Track_Length(Track_Number : Track_ID_T) return Positive;

   --  gets the traversing time in seconds of track with given ID
   --  it seems not realistic because it's indedependent from train!
   function Get_Traversing_Time (Track_Number : Track_ID_T) return Integer;

end Railway.Tracks;
