--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Railway.Train;
with Railway.Network;

package Railway.Trains is
            use Railway.Train, Railway.Network;

   --  attribute 'Partition_ID of unit U returns an integer
   --+ which is the unique id that identifies the partition
   --+ on which unit U is located
   Local_Partition_ID  : Integer := Railway.Trains'Partition_Id;

   Null_Stage : Train_Stage_T := (Null_Platform_ID, Null_Track_ID, -1);

   --  trains definitions

   --  ******************************
   --  Train - description
   Train_1_Name : aliased String := All_Trains_Def(1).Name.all
     & "{" & Integer'Image (Local_Partition_ID) & "}";

   --  Train - definition
   Train_1_Task : aliased Train_T
     (All_Trains_Def(1).Route,
      All_Trains_Def(1).Seats,
      All_Trains_Def(1).prior,
      Train_1_Name'Access,
      1,
      All_Trains_Def(1).category --  ,
     );


   --  ******************************
   --  Train - description
   Train_2_Name : aliased String := All_Trains_Def(2).Name.all
     & "{" & Integer'Image (Local_Partition_ID) & "}";

   --  Train - definition
   Train_2_Task : aliased Train_T
     (All_Trains_Def(2).Route,
      All_Trains_Def(2).Seats,
      All_Trains_Def(2).prior,
      Train_2_Name'Access,
      2,
      All_Trains_Def(2).category --  ,
      --  Ticket_DB_ECMAVE'Access
     );


      --  ******************************
   --  Train - description
   Train_3_Name : aliased String := All_Trains_Def(3).Name.all
     & "{" & Integer'Image (Local_Partition_ID) & "}";

   --  Train - definition
   Train_3_Task : aliased Train_T
     (All_Trains_Def(3).Route,
      All_Trains_Def(3).Seats,
      All_Trains_Def(3).prior,
      Train_3_Name'Access,
      3,
      All_Trains_Def(3).category --  ,
     );


   --  ******************************
   --  Train - description
   Train_4_Name : aliased String := All_Trains_Def(4).Name.all
     & "{" & Integer'Image (Local_Partition_ID) & "}";

   --  Train - definition
   Train_4_Task : aliased Train_T
     (All_Trains_Def(4).Route,
      All_Trains_Def(4).Seats,
      All_Trains_Def(4).prior,
      Train_4_Name'Access,
      4,
      All_Trains_Def(4).category
     );


   --  ******************************
   --  Train - description
   Train_5_Name : aliased String := All_Trains_Def(5).Name.all
     & "{" & Integer'Image (Local_Partition_ID) & "}";

   --  Train - definition
   Train_5_Task : aliased Train_T
     (All_Trains_Def(5).Route,
      All_Trains_Def(5).Seats,
      All_Trains_Def(5).prior,
      Train_5_Name'Access,
      5,
      All_Trains_Def(5).category
     );

end Railway.Trains;
