--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Railway.Traveler;

package Railway.Travelers is
   use Railway.Traveler;

   Name_1 : aliased String := "Mickey Mouse";
   Route_Fwd_1 : aliased  Travel_Route_T :=
     (1 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Venezia,
            Station_To => Madrid
           ));
   Route_Bcw_1 : aliased Travel_Route_T :=
     (1 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Madrid,
            Station_To => Venezia
           ));

   Traveler_1 : Traveler_Task
     (Name => Name_1'Access,
      Stationary_Period => 10,
      Route_Forward => Route_Fwd_1'Access,
      Route_Backward =>Route_Bcw_1'Access
     );


   Name_2 : aliased String := "Minnie Mouse";
   Route_Fwd_2 : aliased  Travel_Route_T :=
     (1 => (Train => Wien_Paris_RT_ID,
            Station_From => Wien,
            Station_To => Paris
           ),
      2 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Paris,
            Station_To => Madrid
           )
     );
   Route_Bcw_2 : aliased Travel_Route_T :=
     (1 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Madrid,
            Station_To => Paris
           ),
        2 => (Train => Wien_Paris_RT_ID,
              Station_From => Paris,
              Station_To => Wien
           ));

   Traveler_2 : Traveler_Task
     (Name => Name_2'Access,
      Stationary_Period => 12,
      Route_Forward => Route_Fwd_2'Access,
      Route_Backward =>Route_Bcw_2'Access
     );


   Name_3 : aliased String := "Goofy Goose";
   Route_Fwd_3 : aliased  Travel_Route_T :=
     (1 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Venezia,
            Station_To => Paris
           ));
   Route_Bcw_3 : aliased Travel_Route_T :=
     (1 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Paris,
            Station_To => Venezia
           ));

   Traveler_3 : Traveler_Task
     (Name => Name_3'Access,
      Stationary_Period => 14,
      Route_Forward => Route_Fwd_3'Access,
      Route_Backward =>Route_Bcw_3'Access
     );


   Name_4 : aliased String := "Pluto the Pup";
   Route_Fwd_4 : aliased  Travel_Route_T :=
     (1 => (Train => Wien_Madrid_EC_ID,
            Station_From => Madrid,
            Station_To => Bruxelles
           ));
   Route_Bcw_4 : aliased Travel_Route_T :=
     (1 => (Train => Wien_Madrid_EC_ID,
            Station_From => Bruxelles,
            Station_To => Madrid
           ));

   Traveler_4 : Traveler_Task
     (Name => Name_4'Access,
      Stationary_Period => 16,
      Route_Forward => Route_Fwd_4'Access,
      Route_Backward =>Route_Bcw_4'Access
     );

   Name_5 : aliased String := "Black Pete";
   Route_Fwd_5 : aliased  Travel_Route_T :=
     (1 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Bruxelles,
            Station_To => Madrid
           ));
   Route_Bcw_5 : aliased Travel_Route_T :=
     (1 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Madrid,
            Station_To => Bruxelles
           ));

   Traveler_5 : Traveler_Task
     (Name => Name_5'Access,
      Stationary_Period => 18,
      Route_Forward => Route_Fwd_5'Access,
      Route_Backward =>Route_Bcw_5'Access
     );

   Name_6 : aliased String := "Scrooge McDuck";
   Route_Fwd_6 : aliased  Travel_Route_T :=
     (1 => (Train => Wien_Paris_RT_ID,
            Station_From => Wien,
            Station_To => Bruxelles
           ),
      2 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Bruxelles,
            Station_To => Madrid
           )
     );
   Route_Bcw_6 : aliased Travel_Route_T :=
     (1 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Madrid,
            Station_To => Bruxelles
           ),
        2 => (Train => Wien_Paris_RT_ID,
              Station_From => Bruxelles,
              Station_To => Wien
           ));

   Traveler_6 : Traveler_Task
     (Name => Name_6'Access,
      Stationary_Period => 12,
      Route_Forward => Route_Fwd_6'Access,
      Route_Backward =>Route_Bcw_6'Access
     );


   Name_7 : aliased String := "Donald Duck";
   Route_Fwd_7 : aliased  Travel_Route_T :=
     (1 => (Train => Bruxelles_Madrid_EC_ID,
            Station_From => Bruxelles,
            Station_To => Paris
           ),
      2 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Paris,
            Station_To => Venezia
           )
     );
   Route_Bcw_7 : aliased Travel_Route_T :=
     (1 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Venezia,
            Station_To => Paris
           ),
        2 => (Train => Bruxelles_Madrid_EC_ID,
              Station_From => Paris,
              Station_To => Bruxelles
           ));

   Traveler_7 : Traveler_Task
     (Name => Name_7'Access,
      Stationary_Period => 22,
      Route_Forward => Route_Fwd_7'Access,
      Route_Backward =>Route_Bcw_7'Access
     );

   Name_8 : aliased String := "Daisy Duck";
   Route_Fwd_8 : aliased  Travel_Route_T :=
     (1 => (Train => Wien_Madrid_EC_ID,
            Station_From => Paris,
            Station_To => Madrid
           ));
   Route_Bcw_8 : aliased Travel_Route_T :=
     (1 => (Train => Wien_Madrid_EC_ID,
            Station_From => Madrid,
            Station_To => Paris
           ));

   Traveler_8 : Traveler_Task
     (Name => Name_8'Access,
      Stationary_Period => 24,
      Route_Forward => Route_Fwd_8'Access,
      Route_Backward =>Route_Bcw_8'Access
     );

   Name_9 : aliased String := "Gladstone Gander";
   Route_Fwd_9 : aliased  Travel_Route_T :=
     (1 => (Train => Wien_Madrid_EC_ID,
            Station_From => Paris,
            Station_To => Madrid
           ));
   Route_Bcw_9 : aliased Travel_Route_T :=
     (1 => (Train => Wien_Madrid_EC_ID,
            Station_From => Madrid,
            Station_To => Paris
           ));

   Traveler_9 : Traveler_Task
     (Name => Name_9'Access,
      Stationary_Period => 26,
      Route_Forward => Route_Fwd_9'Access,
      Route_Backward =>Route_Bcw_9'Access
     );


   Name_10 : aliased String := "Gyro Gearloose";
   Route_Fwd_10 : aliased  Travel_Route_T :=
     (1 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Venezia,
            Station_To => Paris
           ),
      2 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Paris,
            Station_To => Bruxelles
           ),
      3 => (Train => Wien_Madrid_EC_ID,
            Station_From => Bruxelles,
            Station_To => Wien
           )

     );
   Route_Bcw_10 : aliased Travel_Route_T :=
     (1 => (Train => Wien_Madrid_EC_ID,
            Station_From => Wien,
            Station_To => Bruxelles
           ),
      2 => (Train => Bruxelles_Madrid_RT_ID,
            Station_From => Bruxelles,
            Station_To => Paris
           ),
      3 => (Train => Madrid_Venezia_EC_ID,
            Station_From => Paris,
            Station_To => Venezia
           )

     );

   Traveler_10 : Traveler_Task
     (Name => Name_10'Access,
      Stationary_Period => 12,
      Route_Forward => Route_Fwd_10'Access,
      Route_Backward =>Route_Bcw_10'Access
     );


end Railway.Travelers;
