--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

--  the distributed control object
package Distrailway.Central_Control is

   pragma Remote_Call_Interface;

   --  Train state Update message
   procedure Upd_Train
     (Time : Integer;
      Train_Number : Integer;
      Train_Name : String;
      Free_Seats : Integer;
      Seats : Integer;
      Location : String);

   pragma Asynchronous (Upd_Train);

   --  Passenger state Update message
   procedure Upd_Passenger
     (Time : Integer;
      Passenger_Name : String;
      Location : String);

   pragma Asynchronous (Upd_Passenger);

end Distrailway.Central_Control;
