--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Net_View;
with Gdk.Threads;
with GUI_Control;

package body Distrailway.pkgProtected_Net_Map is

   protected body Protected_Net_Map is

      entry Update_Train_Position
        (Time         : Integer;
         Train_Number : Integer;
         Train_Name   : String;
         Free_Seats   : Integer;
         Seats        : Integer;
         Location     : String;
         stat_from : Station_T;
         stat_to   : Station_T;
         pos  : Integer;
         over : Integer
        ) when Inited is
      begin
         Gdk.Threads.Enter;

         Net_View.SetTrainPosition (Gui_Control_Map.View_Map,
                               Train_Number,
                               stat_from,
                               stat_to,
                               pos,
                               over
                                   );
         Gdk.Threads.Leave;
      end Update_Train_Position;

      procedure Initialized is
      begin
         Inited := True;
      end Initialized;

   end Protected_Net_Map;

   task body GUI_Control_Task is
   begin
      GUI_Control.GUI.Init ("Control Panel");

      Gdk.Threads.Enter;
      Gtk_New (Gui_Control_Map);
      Show_All (Gui_Control_Map);
      Gdk.Threads.Leave;

      Protected_Net_Map.Initialized;
   end GUI_Control_Task;

end Distrailway.pkgProtected_Net_Map;
