--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Glib;             use Glib;
with Gtk;              use Gtk;
with Gtk.Enums;        use Gtk.Enums;
with GUI_Railway_Intl; use GUI_Railway_Intl;
with Gui_Sizes;        use Gui_Sizes;

package body Gui_Control_Map_Pkg is

   --  attribute 'Partition_ID of unit U returns an integer
   --+ which is the unique id that identifies the partition
   --+ on which unit U is located
   Local_Partition_ID  : constant Integer := Gui_Control_Map_Pkg'Partition_Id;

   procedure Gtk_New (Gui_Control_Map : out Gui_Control_Map_Access) is
   begin
      Gui_Control_Map := new Gui_Control_Map_Record;
      Gui_Control_Map_Pkg.Initialize (Gui_Control_Map);
   end Gtk_New;

   procedure Initialize
     (Gui_Control_Map : access Gui_Control_Map_Record'Class) is
      pragma Suppress (All_Checks);
      --  Pixmaps_Dir : constant String := "pixmaps/";
   begin
      Gtk.Window.Initialize (Gui_Control_Map, Window_Toplevel);
      Set_Title (Gui_Control_Map, -"Control Panel - Map"
                 & "{" & Integer'Image (Local_Partition_ID) & "}");
      Set_Position (Gui_Control_Map, Win_Pos_Center);
      Set_Modal (Gui_Control_Map, False);

      Set_Default_Size (Gui_Control_Map,
                        Map_Control_Window_Width,
                        Map_Control_Window_Height);

      Gtk_New_Vbox (Gui_Control_Map.Vbox1, False, 0);

      Gtk_New (Gui_Control_Map.Label1, -("CURRENT POSITION OF ALL TRAINS"));
      Set_Alignment (Gui_Control_Map.Label1, 0.5, 0.5);
      Set_Padding (Gui_Control_Map.Label1, 0, 0);
      Set_Justify (Gui_Control_Map.Label1, Justify_Left);
      Set_Line_Wrap (Gui_Control_Map.Label1, False);
      Set_Selectable (Gui_Control_Map.Label1, False);
      Set_Use_Markup (Gui_Control_Map.Label1, False);
      Set_Use_Underline (Gui_Control_Map.Label1, False);

      Pack_Start
        (Gui_Control_Map.Vbox1,
         Gui_Control_Map.Label1,
         Expand  => False,
         Fill    => False,
         Padding => 0);

--        Gtk_New (Gui_Control_Map.Scrolledwindow1);
--        Set_Policy (Gui_Control_Map.Scrolledwindow1,
--                    Policy_Automatic, Policy_Automatic);
--        Set_Shadow_Type (Gui_Control_Map.Scrolledwindow1, Shadow_In);


      Gtk_New (Gui_Control_Map.View_Map);
--        Add (Gui_Control_Map.Scrolledwindow1, Gui_Control_Map.View_Map);

      Pack_Start
        (Gui_Control_Map.Vbox1,
         Gui_Control_Map.View_Map,
         Expand  => True,
         Fill    => True,
         Padding => 0);
--        Pack_Start
--          (Gui_Control_Map.Vbox1,
--           Gui_Control_Map.Scrolledwindow1,
--           Expand  => True,
--           Fill    => True,
--           Padding => 0);
      Add (Gui_Control_Map, Gui_Control_Map.Vbox1);

--        Gtk_New (Gui_Control_Map.Label2, -("CURRENT POSITION OF ALL TRAINS"));
--        Set_Alignment (Gui_Control_Map.Label2, 0.5, 0.5);
--        Set_Padding (Gui_Control_Map.Label2, 0, 0);
--        Set_Justify (Gui_Control_Map.Label2, Justify_Left);
--        Set_Line_Wrap (Gui_Control_Map.Label2, False);
--        Set_Selectable (Gui_Control_Map.Label2, False);
--        Set_Use_Markup (Gui_Control_Map.Label2, False);
--        Set_Use_Underline (Gui_Control_Map.Label2, False);
--
--        Pack_Start
--          (Gui_Control_Map.Vbox1,
--           Gui_Control_Map.Label2,
--           Expand  => False,
--           Fill    => False,
--           Padding => 0);

   end Initialize;

end Gui_Control_Map_Pkg;
