--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
with Glib; use Glib;
with Gdk.GC;
with Gtk.Drawing_Area;

with Railway;         use Railway;

package Net_View is

   type RailMap_Widget_Record is new Gtk.Drawing_Area.Gtk_Drawing_Area_Record
     with private;
   type RailMap_Widget is access all RailMap_Widget_Record'Class;


   procedure Gtk_New (Widget : out RailMap_Widget);
   procedure Initialize (Widget : access RailMap_Widget_Record'Class);
   procedure SetTrainPosition (Widget : access RailMap_Widget_Record'Class;
                               Train : Range_Trains;
                               new_from : Station_T;
                               new_to   : Station_T;
                               new_pos  : Integer;
                               new_over : Integer
                              );


private

   type TrainPos_T is record
      stat_from : Station_T;
      stat_to   : Station_T;
      pos  : Integer;
      over : Integer;
   end record;

   type AllTrainPos_T is array (Range_Trains) of TrainPos_T;

   type RailMap_Widget_Record is new
     Gtk.Drawing_Area.Gtk_Drawing_Area_Record with
      record
         Gc_Trains  : Gdk.GC.Gdk_GC;
         Gc_Line : Gdk.GC.Gdk_GC;
         MapWidth  : Gint;
         MapHeight : Gint;
         MaxTrainUsed : Range_Trains := Range_Trains'First;
         AllTrainsPositions : AllTrainPos_T
           :=
           (
            others => (NullStation, NullStation, 0, 100)
           );
      end record;



end Net_View;
