-----------------------------------------------------------------------
--          GtkAda - Ada95 binding for the Gimp Toolkit              --
--                                                                   --
--                     Copyright (C) 2003                            --
--        Emmanuel Briot, Joel Brobecker and Arnaud Charlet          --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- execuTable, this  unit  does not  by itself cause  the resulting  --
-- execuTable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- execuTable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------

with Gtk.Scrolled_Window;      use Gtk.Scrolled_Window;
with Gtk.Cell_Renderer_Text;   use Gtk.Cell_Renderer_Text;
with Gtk.Cell_Renderer_Toggle; use Gtk.Cell_Renderer_Toggle;
with Gtk.Tree_View;            use Gtk.Tree_View;
with Gtk.Tree_Model;           use Gtk.Tree_Model;
with Gtk.Tree_Store;           use Gtk.Tree_Store;
with Gtk.Tree_View_Column;     use Gtk.Tree_View_Column;
with Glib;                     use Glib;

package Passengers_View is

   procedure Run (Frame : access Gtk_Scrolled_Window_Record'Class);
   function Help return String;
   procedure Add_Line
     (Time : Integer;
      Passenger : String;
      Location : String;
      Parent   : Gtk_Tree_Iter := Null_Iter);

private

   Model    : Gtk_Tree_Store;
   Tree     : Gtk_Tree_View;
   Scrolled : Gtk_Scrolled_Window;
   Col      : Gtk_Tree_View_Column;
   Num      : Gint;
   Text_Render   : Gtk_Cell_Renderer_Text;
   Toggle_Render : Gtk_Cell_Renderer_Toggle;
   Parent, Iter  : Gtk_Tree_Iter;

end Passengers_View;
