--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Distrailway.Central_Control;
with Ada.Text_IO;                 use Ada.Text_IO;
with Railway.Timeref; use Railway.Timeref;
with Railway.Network;              use Railway.Network;

package body Railway.Ticket_Counter is

   protected body Ticket_Counter_T is

      entry Buy_Ticket
        (Passenger_Route : Travel_Ext_Route_T;
         Travel_Index : in out Integer;
         Passenger_Name : String) when True is

         Prefix : constant String := "is queuing at ";

         Index_First_Segment_leg : Integer;
         Leg_of_lower_Train : Integer := Passenger_Route'First;
         Legso_EC : Boolean := False;

      begin

         --           Put_Line (Integer'Image(Integer (To_Duration (Clock - Start_Time)))
         --                     & " " & Passenger_Name &
         --                     "is BUYING ticket for train "
         --                     & All_Trains_Def(Passenger_Route (Passenger_Route'First).Train).Name.all );

         Passed := Clock - Start_Time;

         Distrailway.Central_Control.Upd_Passenger
           (Integer (To_Duration (Passed)),
            Passenger_Name,
            Prefix & Name.all);


         --  search the EC train with lower ID tot start booking
         for Legso_ix in Passenger_Route'First .. (Passenger_Route'Last) loop
            if (All_Trains_Def(Passenger_Route (Legso_ix).Train).category = EC) then
               Legso_EC := True;
               if Passenger_Route(Legso_ix).Train <
                 Passenger_Route (Leg_of_lower_Train).Train
               then
                  Leg_of_lower_Train := Legso_ix;
               end if;
            end if;

         end loop;

         --  starts booking the Train with the lowest Index if EC was found
         if Legso_EC then
            Travel_Index := Leg_of_lower_Train;

            if All_Ticket_DB
              (Passenger_Route (Leg_of_lower_Train).Train)= null then
               Put_Line ("ERROR - Ticket_Counter not specified");
            else
               Put_Line ("START BOOKING - " & Passenger_Name);
               requeue All_Ticket_DB
                 (Passenger_Route (Leg_of_lower_Train).Train).Book_Leg;
            end if;
         end if;

         --  Index_First_Segment_leg := Passenger_Route (Passenger_Route'First).Route'First;
         Index_First_Segment_leg := Passenger_Route'First;

         Passed := Clock - Start_Time;


         Distrailway.Central_Control.Upd_Passenger
           (Integer (To_Duration (Passed)),
            Passenger_Name,
            "is waiting for train "
            & All_Trains_Def(Passenger_Route (Passenger_Route'First).Train).Name.all
            & " at platform "
            & AllPlatformsReference(Passenger_Route(Passenger_Route'First).Plat_From).Name.all
           );


         --  the Passenger is enqueued on the Depart channel of the first leg

         requeue AllPlatformsReference
           (Passenger_Route (Index_First_Segment_leg).Plat_From).Depart
           (Passenger_Route (Index_First_Segment_leg).Train);
      end Buy_Ticket;

   end Ticket_Counter_T;

end Railway.Ticket_Counter;
