--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Railway;          use Railway;
with Ada.Real_Time;    use Ada.Real_Time;
with Railway.Types;    use Railway.Types;
with Railway.Platform; use Railway.Platform;

--  there is a ticket counter for each Station
--  if a Route does not need booking, the ticket
--  is sold immediately. Otherwise, the booking
--  procedure is started

package Railway.Ticket_Counter is

   type Ticket_Counter_T;
   type Ticket_Counter_Ref_T is access all Ticket_Counter_T;

   Passed : Time_Span;


   protected type Ticket_Counter_T (Name : String_Ref_T) is

      entry Buy_Ticket
        (Passenger_Route : Travel_Ext_Route_T;
         Travel_Index : in out Integer;
         Passenger_Name : String);

   end Ticket_Counter_T;

end Railway.Ticket_Counter;
