--------------------------------------------------------
--  Paolo Santi - 2007                                --
--  Railway (il ritorno) 1.1                          --
--  Universita' di Padova                             --
--  Anno accademico 2006/2007                         --
--  Laurea Magistrale in Informatica                  --
--  Corso di Sistemi Concorrenti e Distribuiti        --
--                                                    --
--  Rielaborazione di un progetto di Alessandro Temil --
--                                                    --
--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Ada.Text_IO;           use Ada.Text_IO;
with Ada.Exceptions;        use Ada.Exceptions;
with Ada.Real_Time;         use Ada.Real_Time;
with Railway.Stations;     use Railway.Stations;

package body Railway.Traveler is

   task body Traveler_Task is

      AlName : aliased constant String := Name.all;
      Travel_Index : Integer;

   begin
      loop

         Travel_Index := 1;
         Passenger_Travel (Route_Forward.all,  Travel_Index, AlName
                           & "{" & Integer'Image (Local_Partition_ID)
                           & "}");
         delay To_Duration (Milliseconds (Stationary_Period*1000));

         Travel_Index := 1;
         Passenger_Travel (Route_Backward.all,  Travel_Index, AlName
                           & "{" & Integer'Image (Local_Partition_ID)
                           & "}");
         delay To_Duration (Milliseconds (Stationary_Period*1000));

      end loop;
   exception
      when E: Program_Error =>
         Put_Line (Exception_Information (E));
      when A : others =>
         Put_Line (Exception_Name (A));
   end Traveler_Task;

end Railway.Traveler;
