--------------------------------------------------------
--  Copyright (C) 2006                                --
--  Alessandro Temil                                  --
--  Railway 1.0                                       --
--  Concurrent and Distributed Systems class project  --
--  Master Degree in Computer Science                 --
--  Academic year 2005/6                              --
--  Dept. of Pure and Applied Mathematics             --
--  University of Padua, Italy                        --
--                                                    --
--  This program is free software; you can            --
--  redistribute it and/or modify it under the terms  --
--  of the GNU General Public License as published    --
--  by the Free Software Foundation; either           --
--  version 2 of the License, or (at your option)     --
--  any later version.                                --
--------------------------------------------------------

with Railway.Types;          use Railway.Types;

package Railway.Traveler is

      --  attribute 'Partition_ID of unit U returns an integer
      --+ which is the unique id that identifies the partition
      --+ on which unit U is located
      Local_Partition_ID  : Integer := Railway.Traveler'Partition_Id;

      task type Traveler_Task
        (
         Name                    : String_Ref_T;
         Stationary_Period       : Positive;
         Route_Forward           : Travel_Route_Ref_T;
         Route_Backward          : Travel_Route_Ref_T
        );

   type Traveler_Task_Ref is access all Traveler_Task;


end Railway.Traveler;
